global
  log /dev/log  local0
  log /dev/log  local1 notice
  chroot /var/lib/haproxy
  stats socket /run/haproxy/admin.sock mode 660 level admin
  stats timeout 30s
  user haproxy
  group haproxy
  daemon
    maxconn 2048
    tune.ssl.default-dh-param 2048

  # Default SSL material locations
  ca-base /etc/ssl/certs
  crt-base /etc/ssl/private

  ssl-default-bind-ciphers ECDH+AESGCM:DH+AESGCM:ECDH+AES256:DH+AES256:ECDH+AES128:DH+AES:ECDH+3DES:DH+3DES:RSA+AESGCM:RSA+AES:RSA+3DES:!aNULL:!MD5:!DSS
  ssl-default-bind-options no-sslv3

defaults
  option forwardfor
  option http-server-close
  log  global
  mode  http
  option  httplog
  option  dontlognull
  timeout connect 5s
  timeout client  50s
  timeout server  50s
  timeout tunnel  1h
  errorfile 400 /etc/haproxy/errors/400.http
  errorfile 403 /etc/haproxy/errors/403.http
  errorfile 408 /etc/haproxy/errors/408.http
  errorfile 500 /etc/haproxy/errors/500.http
  errorfile 502 /etc/haproxy/errors/502.http
  errorfile 503 /etc/haproxy/errors/503.http
  errorfile 504 /etc/haproxy/errors/504.http

  frontend http
    bind *:80
    mode http
    redirect scheme https code 301 if !{ ssl_fc }
    default_backend test_api

  frontend https
    bind *:443 ssl
    option forwardfor
    option forwardfor except 127.0.0.0/8
    # ddos protect
    acl HAS_CF_CONNECTING_IP hdr_cnt(CF-Connecting-IP) eq 1
    acl HAS_X_FORWARDED_FOR hdr_cnt(X-Forwarded-For) eq 1
    tcp-request content track-sc0 hdr_ip(CF-Connecting-IP,-1) if HTTP HAS_CF_CONNECTING_IP
    tcp-request content track-sc0 hdr_ip(X-Forwarded-For,-1) if HTTP !HAS_CF_CONNECTING_IP HAS_X_FORWARDED_FOR

    # Stick Table Definitions
    #  - conn_cur: count active connections
    #  - conn_rate(3s): average incoming connection rate over 3 seconds
    #  - http_err_rate(10s): Monitors the number of errors generated by an IP over a period of 10 seconds
    #  - http_req_rate(10s): Monitors the number of request sent by an IP over a period of 10 seconds
    stick-table type ip size 500k expire 30s store conn_cur,conn_rate(3s),http_req_rate(10s),http_err_rate(10s)

    # TARPIT the new connection if the client already has 10 opened
    http-request tarpit if { src_conn_cur ge 10 }

    # TARPIT the new connection if the client has opened more than 20 connections in 3 seconds
    http-request tarpit if { src_conn_rate ge 20 }

    # TARPIT the connection if the client has passed the HTTP error rate (10s)
    http-request tarpit if { sc0_http_err_rate() gt 20 }

    # TARPIT the connection if the client has passed the HTTP request rate (10s)
    http-request tarpit if { sc0_http_req_rate() gt 100 }

    # For country blocking and blacklists, if no CF-Connecting-IP is present, use the last value of X-Forwarded-For
    acl HAS_CF_CONNECTING_IP req.fhdr(CF-Connecting-IP) -m found
    http-request set-header CF-Connecting-IP %[req.hdr_ip(X-Forwarded-For,-1)] if !HAS_CF_CONNECTING_IP
    tcp-request inspect-delay 5s
    # end ddos protect
    reqadd X-Forwarded-Proto:\ https

    acl app_stats path_beg -i /stats
    use_backend be_stats if app_stats

    acl test_api_req hdr(host) -i api.rsc.network -i www.api.rsc.network
    use_backend test_api if test_api_req

    default_backend test_api

  backend test_api
    option httpchk HEAD /status
    http-check expect status 200
    cookie serverid insert
    redirect scheme https if !{ ssl_fc }
    server app1 10.130.72.84:3009 cookie app1 check

  backend be_stats
    server stats1 localhost:6060
    stats enable
    stats hide-version  # Hide HAProxy version
    stats realm Haproxy Statistics
    stats uri /
    stats auth test:test@2020
